#include <avr/io.h>
#define F_CPU 8000000UL
#include <util/delay.h>
#include <avr/interrupt.h>
#include <compat/deprecated.h>
#include <stdio.h>


#define zero 0x3f
#define one 0x06
#define two 0x5b
#define three 0x4f
#define four 0x66
#define five 0x6d
#define six 0x7d
#define seven 0x07
#define eight 0x7f
#define nine 0x6f
#define _A 0x77
#define _B 0xfb
#define _C 0x39
#define _D 0xaf
#define _E 0x79
#define _F 0x71
unsigned int no[10] = {zero,one,two,three,four,five,six,seven,eight,nine};
unsigned int ch[6] = {_A,_B,_C,_D,_E,_F};

unsigned int global_currentkey;

unsigned int i,j = 0;
SIGNAL(SIG_PIN_CHANGE0)
{
     //do somethings when SHIFT press
     if (j%2 == 0)
	  {
	       printf("SHIFT KEY PRESS %d\n",i);
	       PORTB = no[i%10];
	       i++;
	  }
     j++;
}


SIGNAL(SIG_OVERFLOW2)
{

     //     printf("Enter INTERRUPT!\t");
     unsigned int tmp,i;
     DDRC = 0xf0;
     PORTC = 0x0f;
     
     for(i=0;i<10;i++)
	  asm("nop");
     
     if (PINC != 0x0f)
	  {
	       //	       printf("one KEY found!\n");
	       tmp = PINC;
	       
	       DDRC = 0x0f;
	       PORTC = 0xf0;

	       for(i=0;i<10;i++)
		    asm("nop");
	       if (PINC != 0xf0)
		    {
			 switch (tmp | PINC)
			      {
			      case 231:
				   global_currentkey = 0;
				   break;
			      case 215:
				   global_currentkey = 1;
				   break;
			      case 183:
				   global_currentkey = 2;
				   break;
			      case 119:
				   global_currentkey = 3;
				   break;
			      case 235:
				   global_currentkey = 4;
				   break;
			      case 219:
				   global_currentkey = 5;
				   break;
			      case 187:
				   global_currentkey = 6;
				   break;
			      case 123:
				   global_currentkey = 7;
				   break;
			      case 237:
				   global_currentkey = 8;
				   break;
			      case 221:
				   global_currentkey = 9;
				   break;
			      case 189:
				   global_currentkey = 10;
				   break;
			      case 125:
				   global_currentkey = 11;
				   break;
			      case 238:
				   global_currentkey = 12;
				   break;
			      case 222:
				   global_currentkey = 13;
				   break;
			      case 190:
				   global_currentkey = 14;
				   break;
			      case 126:
				   global_currentkey = 15;
				   break;
			      }
				   
			 printf("%d\n",global_currentkey);
			 PORTB = no[global_currentkey];

			 unsigned int i;
			 for(i=0;i<5;i++)
			      _delay_ms(250);
		    }
	  }
     //     printf("\n");

}


void init_io()
{
     //PORT-B for 8-segement DATA, High Active
     PORTB = 0xff;
     DDRB = 0xff; //output

     //PORT-D for 8-segemnet ADDR, Low Active (PD2-PD5)
     PORTD = 0x00;
     DDRD = 0xff; //output

     PORTA = 0xff;
     DDRA = 0xff;
}

void init_shift_key() //PA0
{
     PCMSK0 = _BV(PCINT0);
     GICR = _BV(PCIE0);
}

void init_timer()
{
     TCNT2 = 0;
     TCCR2 = _BV(CS22) | _BV(CS20);
     TIMSK = _BV(TOIE2);       
}

int uart_putchar(char c)
{
     if (c=='\n')
	  uart_putchar('\r');
     loop_until_bit_is_set(UCSR0A,UDRE0);
     UDR0 = c;
     return 0;
}

int uart_getchar()
{
     loop_until_bit_is_set(UCSR0A,RXC0);
     return UDR0;
}

void init_uart()
{
     UCSR0B = /* _BV(RXCIE0) | _BV(TXCIE0) | */ _BV(RXEN0) | _BV(TXEN0);
     
     UBRR0H = 0;
     UBRR0L = 8; //57600 @ 8MHz Clock
     
     fdevopen(uart_putchar,uart_getchar);
}



int main()
{
     init_io();
     init_shift_key();
     init_timer();
     init_uart();

     printf("Hello!\n");
     

     sei();
     while(1)
	  {
	  }
}
